; main.s
; Desenvolvido para a placa EK-TM4C1294XL
; Ex. timer2 contando 700ms 1x com interrupo
; Prof. Guilherme de S. Peron	- 12/03/2018
; Prof. Marcos E. P. Monteiro	- 12/03/2018
; Prof. DaLuz           		- 25/02/2022

;################################################################################
; Configurar o timer0 para alternar um led a cada 500ms com IRQ. Modo: peridico
; Configurar o timer2 para ascender um led aps 700ms apenas uma vez com IRQ
; Modo: One Shot
;################################################################################

;################################################################################
        THUMB                        ; Instrues do tipo Thumb-2
;################################################################################
		
; Definies de Valores
BIT0	EQU 2_0001
BIT1	EQU 2_0010
;################################################################################
; rea de Dados - Declaraes de variveis
		AREA  DATA, ALIGN=2
		; Se alguma varivel for chamada em outro arquivo
		;EXPORT  <var> [DATA,SIZE=<tam>]   ; Permite chamar a varivel <var> a 
		                                   ; partir de outro arquivo
;<var>	SPACE <tam>                        ; Declara uma varivel de nome <var>
                                           ; de <tam> bytes a partir da primeira 
                                           ; posio da RAM		

;################################################################################
; rea de Cdigo - Tudo abaixo da diretiva a seguir ser armazenado na memria de 
;                  cdigo
        AREA    |.text|, CODE, READONLY, ALIGN=2

		; Se alguma funo do arquivo for chamada em outro arquivo	
        EXPORT Start                ; Permite chamar a funo Start a partir de 
			                        ; outro arquivo. No caso startup.s
		; Se chamar alguma funo externa	
        ;IMPORT <func>              ; Permite chamar dentro deste arquivo uma 
									; funo <func>
		IMPORT  PLL_Init
		IMPORT  SysTick_Init
		IMPORT  SysTick_Wait1ms			
		IMPORT  GPIO_Init
        IMPORT  PortN_Output
        IMPORT  PortJ_Input	
		IMPORT  Timer0A_Init
		IMPORT  Timer2A_Init
;################################################################################
; Funo main()
Start  		
	BL		PLL_Init				;Chama a subrotina para alterar o clock do microcontrolador para 80MHz
	BL		SysTick_Init
	BL		GPIO_Init				;Chama a subrotina que inicializa os GPIO
	
	LDR		R0, =40000000           ;Carrega o R0 como parmetro de entrada para o timer estourar a 500ms peridico
	BL		Timer0A_Init

	LDR		R0, =60000000			;Carrega o R0 como parmetro de entrada para o timer estourar aps 700ms one shot
	BL		Timer2A_Init

MainLoop
	B MainLoop						;Volta para o lao principal
;################################################################################
; Fim do Arquivo
;################################################################################
    ALIGN							;Garante que o fim da seo est alinhada 
    END								;Fim do arquivo